' This class is "generated" and will be overwritten.
' Your customizations should be made in RStatusRecord.vb

Imports System.Data.SqlTypes
Imports BaseClasses
Imports BaseClasses.Data
Imports BaseClasses.Data.SqlProvider

Namespace Persons.Business

''' <summary>
''' The generated superclass for the <see cref="RStatusRecord"></see> class.
''' </summary>
''' <remarks>
''' This class is not intended to be instantiated directly.  To obtain an instance of this class, 
''' use the methods of the <see cref="RStatusTable"></see> class.
''' </remarks>
''' <seealso cref="RStatusTable"></seealso>
''' <seealso cref="RStatusRecord"></seealso>

<Serializable()> Public Class BaseRStatusRecord
	Inherits PrimaryKeyRecord
	

	Public Shared Shadows ReadOnly TableUtils As RStatusTable = RStatusTable.Instance

	' Constructors
 
	Protected Sub New()
		MyBase.New(TableUtils)
	End Sub

	Protected Sub New(ByVal record As PrimaryKeyRecord)
		MyBase.New(record, TableUtils)
	End Sub
	
	'Evaluates Initialize when->Inserting record formulas specified at the data access layer
    Public Overridable Sub RStatusRecord_InsertingRecord(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles Me.InsertingRecord
        'Apply Initialize->Inserting record formula only if validation is successful.
        	        Dim RStatusRec As RStatusRecord = CType(sender,RStatusRecord)
        Validate_Inserting()
        If Not RStatusRec Is Nothing AndAlso Not RStatusRec.IsReadOnly Then
                End If
    End Sub

	'Evaluates Initialize when->Updating record formulas specified at the data access layer
    Public Overridable Sub RStatusRecord_UpdatingRecord(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles Me.UpdatingRecord
        'Apply Initialize->Updating record formula only if validation is successful.
        	        Dim RStatusRec As RStatusRecord = CType(sender,RStatusRecord)
        Validate_Updating()
        If Not RStatusRec Is Nothing AndAlso Not RStatusRec.IsReadOnly Then
                End If
    End Sub
    
    'Evaluates Initialize when->Reading record formulas specified at the data access layer
    Public Overridable Sub RStatusRecord_ReadRecord(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.ReadRecord
        'Apply Initialize->Reading record formula only if validation is successful.
        	        Dim RStatusRec As RStatusRecord = CType(sender,RStatusRecord)
        If Not RStatusRec Is Nothing AndAlso Not RStatusRec.IsReadOnly Then
                End If
    End Sub
    
   'Evaluates Validate when->Inserting formulas specified at the data access layer
   Public Overridable Sub Validate_Inserting ()
		Dim fullValidationMessage As String = ""
		Dim validationMessage As String = ""

		dim formula as String = ""


		If validationMessage <> "" AndAlso validationMessage.ToLower() <> "true" Then
			fullValidationMessage &= validationMessage & vbCrLf
		End If

		If fullValidationMessage <> "" Then
			Throw New Exception(fullValidationMessage)
		End If 
	End Sub
	
	'Evaluates Validate when->Updating formulas specified at the data access layer
   Public Overridable Sub Validate_Updating ()
		Dim fullValidationMessage As String = ""
		Dim validationMessage As String = ""

		dim formula as String = ""


		If validationMessage <> "" AndAlso validationMessage.ToLower() <> "true" Then
			fullValidationMessage &= validationMessage & vbCrLf
		End If

		If fullValidationMessage <> "" Then
			Throw New Exception(fullValidationMessage)
		End If 
	End Sub
 
	Public Overridable Function EvaluateFormula(ByVal formula As String, Optional ByVal dataSourceForEvaluate As BaseClasses.Data.BaseRecord = Nothing, Optional ByVal format As String = Nothing) As String

		Dim e As Data.BaseFormulaEvaluator = New Data.BaseFormulaEvaluator()

            ' All variables referred to in the formula are expected to be
            ' properties of the DataSource.  For example, referring to
            ' UnitPrice as a variable will refer to DataSource.UnitPrice
            e.DataSource = dataSourceForEvaluate

            Dim resultObj As Object = e.Evaluate(formula)
            If resultObj Is Nothing Then
                Return ""
            End If
        	Return resultObj.ToString()
	End Function







#Region "Convenience methods to get/set values of fields"

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's RStatus_.RStatusId field.
	''' </summary>
	Public Function GetRStatusIdValue() As ColumnValue
		Return Me.GetValue(TableUtils.RStatusIdColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's RStatus_.RStatusId field.
	''' </summary>
	Public Function GetRStatusIdFieldValue() As Byte
		Return CType(Me.GetValue(TableUtils.RStatusIdColumn).ToByte(), Byte)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's RStatus_.RStatusId field.
	''' </summary>
	Public Sub SetRStatusIdFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.RStatusIdColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's RStatus_.RStatusId field.
	''' </summary>
	Public Sub SetRStatusIdFieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.RStatusIdColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's RStatus_.RStatusId field.
	''' </summary>
	Public Sub SetRStatusIdFieldValue(ByVal val As Double)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.RStatusIdColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's RStatus_.RStatusId field.
	''' </summary>
	Public Sub SetRStatusIdFieldValue(ByVal val As Decimal)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.RStatusIdColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's RStatus_.RStatusId field.
	''' </summary>
	Public Sub SetRStatusIdFieldValue(ByVal val As Int64)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.RStatusIdColumn)
	End Sub
	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's RStatus_.RStatus field.
	''' </summary>
	Public Function GetRStatusValue() As ColumnValue
		Return Me.GetValue(TableUtils.RStatusColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's RStatus_.RStatus field.
	''' </summary>
	Public Function GetRStatusFieldValue() As String
		Return CType(Me.GetValue(TableUtils.RStatusColumn).ToString(), String)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's RStatus_.RStatus field.
	''' </summary>
	Public Sub SetRStatusFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.RStatusColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's RStatus_.RStatus field.
	''' </summary>
	Public Sub SetRStatusFieldValue(ByVal val As String)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.RStatusColumn)
	End Sub



#End Region

#Region "Convenience methods to get field names"

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's RStatus_.RStatusId field.
	''' </summary>
	Public Property RStatusId() As Byte
		Get 
			Return CType(Me.GetValue(TableUtils.RStatusIdColumn).ToByte(), Byte)
		End Get
		Set (ByVal val As Byte) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.RStatusIdColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property RStatusIdSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.RStatusIdColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property RStatusIdDefault() As String
        Get
            Return TableUtils.RStatusIdColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's RStatus_.RStatus field.
	''' </summary>
	Public Property RStatus() As String
		Get 
			Return CType(Me.GetValue(TableUtils.RStatusColumn).ToString(), String)
		End Get
		Set (ByVal Value As String) 
			Me.SetString(value, TableUtils.RStatusColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property RStatusSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.RStatusColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property RStatusDefault() As String
        Get
            Return TableUtils.RStatusColumn.DefaultValue
        End Get
    End Property



#End Region

End Class
End Namespace
